import 'package:fluid/src/flow/debounce_flow.dart';
import 'package:fluid/src/flow/distinct_flow.dart';
import 'package:fluid/src/flow/flow.dart';
import 'package:fluid/src/flow/mapping_flow.dart';
import 'package:fluid/src/flow/stream_flow.dart';

extension FlowExtensions<T> on Flow<T> {
  Flow<T2> map<T2>(FlowMapper<T, T2> mapper) {
    return MappingFlow(this, mapper);
  }

  Flow<T> debounce(Duration window) {
    return DebounceFlow(this, window);
  }

  Flow<T> distinct() {
    return DistinctFlow(this);
  }
}

extension StreamExtension<T> on Stream<T> {
  Flow<T> asFlow(T initialValue) {
    return StreamFlow(this, initialValue);
  }
}
